/* $Header: /cvsroot/lesstif/lesstif/test/Xm/scale/test19.c,v 1.1 2001/09/21 08:08:57 amai Exp $
  SF [ lesstif-Bugs-463352 ] Artifacts with XmScale show value
  
  With LessTif 0.92.32 compiled from source on a RedHat
  6.2 system (x86), the attached program does not properly clear the
  XmScale's value after the bounds are changed.  Specifically, the values
  between 10 and 20 are wider than what was possible when the widget was
  created and are not completely cleared.
 */

#include <stdlib.h>
#include <stdio.h>

#include <Xm/Xm.h>
#include <Xm/Scale.h>
#include <X11/keysym.h>

void dragCallback(Widget w, XtPointer clientData, XtPointer callData)
{
    XmScaleCallbackStruct *cbs = (XmScaleCallbackStruct *)callData;

    printf ("dragCallback: %d\n", cbs->value);
}

void valueChangedCallback(Widget w, XtPointer clientData, XtPointer callData)
{
    XmScaleCallbackStruct *cbs = (XmScaleCallbackStruct *)callData;

    printf ("valueChangedCallback: %d\n", cbs->value);    
}


int
main(int argc, char *argv[])
{
  Widget toplevel, one;
  XtAppContext app;
  int value;

  XtSetLanguageProc(NULL, NULL, NULL);

  toplevel = XtVaAppInitialize(&app, "Scale", NULL, 0, &argc, argv, NULL, NULL);

  one = XtVaCreateManagedWidget("sb", xmScaleWidgetClass, toplevel, 
                                XmNorientation, XmHORIZONTAL, 
                                XmNscaleWidth, 100, NULL);

  XtAddCallback(one, XmNdragCallback, dragCallback, NULL);
  XtAddCallback(one, XmNvalueChangedCallback, valueChangedCallback, NULL);

  XtRealizeWidget(toplevel);
  XtVaSetValues(one, XmNscaleMultiple, 2, NULL);
  LessTifTestWaitForIt(toplevel);

  LessTifTestKeyPress(one, XK_Right, ControlMask);
  XtVaGetValues(one, XmNvalue, &value, NULL);

  exit((value == 2) ? 0 : 1);
}
